<template>
	<div class="statistics-order-detail-hotspot-area-container layout-padding">
		<div class="layout-padding-auto layout-padding-view pd20">
			<el-form :model="state.queryParams" ref="queryParamsRef" inline @submit.native.prevent>
				<el-form-item label="查询时间段" prop="crTime">
					<el-date-picker
						v-model="state.queryParams.crTime"
						type="datetimerange"
						unlink-panels
						range-separator="至"
						start-placeholder="开始时间"
						end-placeholder="结束时间"
						:shortcuts="shortcuts"
						@change=""
						:clearable="false"
						value-format="YYYY-MM-DD[T]HH:mm:ss"
						:default-time="defaultTimeStartEnd"
					/>
				</el-form-item>
				<el-form-item>
					<el-button type="primary" @click="handleQuery" :loading="state.loading"> <SvgIcon name="ele-Search" class="mr5" />查询 </el-button>
					<el-button @click="resetQuery(queryParamsRef)" :loading="state.loading" class="default-button">
						<SvgIcon name="ele-Refresh" class="mr5" />重置
					</el-button>
				</el-form-item>
			</el-form>
			<vxe-toolbar
				ref="toolbarRef"
				:loading="state.loading"
				custom
				:refresh="{
					queryMethod: queryList,
				}"
				:tools="[{ toolRender: { name: 'exportCurrent' } }, { toolRender: { name: 'exportAll' } }]"
			>
				<template #buttons>
					<el-button type="primary" @click="onJbExport" :disabled="isChecked" :loading="state.loading"
						><SvgIcon name="iconfont icon-daochu" class="mr5" />交办单导出
					</el-button>
				</template>
			</vxe-toolbar>
			<div style="overflow: hidden; width: 100%; height: 100%; flex: 1">
				<vxe-table
					border
					:loading="state.loading"
					:data="state.tableData"
					:column-config="{ resizable: true }"
					:row-config="{ isCurrent: true, isHover: true, height: 30, useKey: true }"
					ref="tableRef"
					height="auto"
					auto-resize
					show-overflow
					:scrollY="{ enabled: true, gt: 100 }"
					id="statisticsOrderDetailHotspotArea"
					:custom-config="{
						storage: true,
					}"
					showHeaderOverflow
					:params="{ exportMethod: exportMethod, exportParams: requestParams }"
					@checkbox-all="selectAllChangeEvent"
					@checkbox-change="selectChangeEvent"
				>
					<vxe-column type="checkbox" width="50" align="center"></vxe-column>
					<vxe-column field="expiredStatusText" title="状态" width="60" align="center">
						<template #default="{ row }">
							<span :class="'overdue-status-' + row.expiredStatus" :title="row.expiredStatusText"></span>
						</template>
					</vxe-column>
					<vxe-column field="statusText" title="工单状态" width="100">
						<template #default="{ row }">
							<el-text type="danger" tag="b" v-if="[1, 2, 3, 9, 101, 102, 103, 104, 105, 200].includes(row.status)">{{ row.statusText }}</el-text>
							<span v-else>{{ row.statusText }}</span>
						</template>
					</vxe-column>
					<vxe-column field="sourceChannel" title="来源渠道" width="110"></vxe-column>
					<vxe-column field="currentStepName" title="当前节点" width="100"></vxe-column>
					<vxe-column field="reTransactNum" title="重办次数" width="100"></vxe-column>
					<vxe-column field="isUrgentText" title="是否紧急" width="100"></vxe-column>
					<vxe-column field="orderScreenStatusText" title="甄别状态" width="100"></vxe-column>
					<vxe-column field="no" title="工单编码" width="140"></vxe-column>
					<vxe-column field="title" title="工单标题" width="200">
						<template #default="{ row }">
							<order-detail :order="row" @updateList="queryList">{{ row.title }}</order-detail>
						</template>
					</vxe-column>
					<vxe-column field="creationTime" title="受理时间" width="160">
						<template #default="{ row }">
							{{ formatDate(row.creationTime, 'YYYY-mm-dd HH:MM:SS') }}
						</template>
					</vxe-column>
					<vxe-column field="expiredTime" title="期满时间" width="160">
						<template #default="{ row }">
							{{ formatDate(row.expiredTime, 'YYYY-mm-dd HH:MM:SS') }}
						</template>
					</vxe-column>
					<vxe-column field="actualHandleOrgName" title="接办部门" width="140"></vxe-column>
					<vxe-column field="actualHandleTime" title="接办时间" width="160">
						<template #default="{ row }">
							{{ formatDate(row.actualHandleTime, 'YYYY-mm-dd HH:MM:SS') }}
						</template>
					</vxe-column>
					<vxe-column field="filedTime" title="办结时间" width="160">
						<template #default="{ row }">
							{{ formatDate(row.filedTime, 'YYYY-mm-dd HH:MM:SS') }}
						</template>
					</vxe-column>
					<vxe-column field="acceptType" title="受理类型" width="110"></vxe-column>
					<vxe-column field="hotspotSpliceName" title="热点全称" width="150"></vxe-column>
					<vxe-column field="hotspotName" title="热点分类" width="150"></vxe-column>
					<vxe-column field="acceptorName" title="受理人" width="120"></vxe-column>
				</vxe-table>
			</div>
			<pagination
				@pagination="queryList"
				:total="state.total"
				v-model:current-page="state.queryParams.PageIndex"
				v-model:page-size="state.queryParams.PageSize"
				:disabled="state.loading"
			/>
		</div>
	</div>
</template>

<script setup lang="tsx" name="statisticsOrderDetailHotspotArea">
import { computed, defineAsyncComponent, onMounted, reactive, ref } from 'vue';
import { formatDate } from '@/utils/formatTime';
import {
  statisticsOrderHotDetailExport,
  statisticsOrderHotDetail,
  statisticsOrderHotSatisfyDetail,
  statisticsOrderHotSatisfyDetailExport,
  statisticsOrderHotAcceptDetail,
  statisticsOrderHotAcceptDetailExport,
  departmentHotSmallDetailExport,
  departmentHotSmallDetail,
  departmentHotDetailNew, departmentHotDetailNewExport,
} from '@/api/statistics/order';
import { useRoute } from 'vue-router';
import {
	centerEnterpriseSpecialistLetterDetail,
	centerEnterpriseSpecialistLetterDetailExport,
	centerUnreceivedDetail,
	centerUnreceivedDetailExport,
} from '@/api/statistics/center';
import { exportAssignment } from '@/utils/tools';
import { defaultDate, defaultTimeStartEnd, shortcuts } from '@/utils/constants';
import { FormInstance } from 'element-plus';

// 引入组件
const OrderDetail = defineAsyncComponent(() => import('@/components/OrderDetail/index.vue')); // 工单详情
const pagination = defineAsyncComponent(() => import('@/components/ProTable/components/Pagination.vue')); // 分页

// 定义变量内容
const state = reactive<any>({
	queryParams: {
		// 查询条件
		PageIndex: 1,
		PageSize: 20,
		State: null, // 特提状态
		Keyword: null, // 关键字
		crTime: defaultDate,
		StartTime: null,
		EndTime: null,
	},
	tableData: [], //表单
	loading: false, // 加载
	total: 0, // 总数
});
/** 获取列表 */
const route = useRoute();
const routeQueryParams = route.query;
const requestParams = ref({});
const exportMethod = ref();
const queryList = () => {
	state.loading = true;
	const type = routeQueryParams.type;
	switch (type) {
		case 'hotspotArea': // 热点区域明细
			exportMethod.value = statisticsOrderHotDetailExport; // 导出接口
			requestParams.value = {
				PageIndex: state.queryParams.PageIndex,
				PageSize: state.queryParams.PageSize,
				HotspotId: routeQueryParams.HotspotId,
				AreaCode: routeQueryParams.AreaCode,
				StartTime: state.queryParams.crTime[0],
				EndTime: state.queryParams.crTime[1],
			};
			statisticsOrderHotDetail(requestParams.value)
				.then((res: any) => {
					state.tableData = res.result?.items ?? [];
					state.total = res.result?.total ?? 0;
					state.loading = false;
				})
				.catch(() => {
					state.loading = false;
				});
			break;
		case 'hotspotAccept': // 热点受理类型明细
			exportMethod.value = statisticsOrderHotAcceptDetailExport; // 导出接口
			requestParams.value = {
				PageIndex: state.queryParams.PageIndex,
				PageSize: state.queryParams.PageSize,
				HotspotId: routeQueryParams.HotspotId,
				AcceptTypeCode: routeQueryParams.AcceptTypeCode,
				StartTime: state.queryParams.crTime[0],
				EndTime: state.queryParams.crTime[1],
			};
			statisticsOrderHotAcceptDetail(requestParams.value)
				.then((res: any) => {
					state.tableData = res.result?.items ?? [];
					state.total = res.result?.total ?? 0;
					state.loading = false;
				})
				.catch(() => {
					state.loading = false;
				});
			break;
		case 'hotspotSatisfied': // 热点满意度明细
			exportMethod.value = statisticsOrderHotSatisfyDetailExport; // 导出接口
			requestParams.value = {
				PageIndex: state.queryParams.PageIndex,
				PageSize: state.queryParams.PageSize,
				HotspotId: routeQueryParams.HotspotId,
				HotspotName: routeQueryParams.HotspotName,
				StartTime: state.queryParams.crTime[0],
				EndTime: state.queryParams.crTime[1],
				TypeId: routeQueryParams.TypeId,
				TitleCode: routeQueryParams.TitleCode,
			};
			statisticsOrderHotSatisfyDetail(requestParams.value)
				.then((res: any) => {
					state.tableData = res.result?.items ?? [];
					state.total = res.result?.total ?? 0;
					state.loading = false;
				})
				.catch(() => {
					state.loading = false;
				});
			break;
		case 'unSigned': // 工单未签收详情
			exportMethod.value = centerUnreceivedDetailExport; // 导出接口
			requestParams.value = {
				PageIndex: state.queryParams.PageIndex,
				PageSize: state.queryParams.PageSize,
				OrgCode: routeQueryParams.OrgCode,
				DataSoure: routeQueryParams.DataSoure,
				StartTime: state.queryParams.crTime[0],
				EndTime: state.queryParams.crTime[1],
			};
			centerUnreceivedDetail(requestParams.value)
				.then((res: any) => {
					state.tableData = res.result?.items ?? [];
					state.total = res.result?.total ?? 0;
					state.loading = false;
				})
				.catch(() => {
					state.loading = false;
				});
			break;
		case 'detailCorporateSpecial': // 企业专席明细
			exportMethod.value = centerEnterpriseSpecialistLetterDetailExport; // 导出接口
			requestParams.value = {
				PageIndex: state.queryParams.PageIndex,
				PageSize: state.queryParams.PageSize,
				userId: routeQueryParams.userId,
				StartTime: state.queryParams.crTime[0],
				EndTime: state.queryParams.crTime[1],
			};
			centerEnterpriseSpecialistLetterDetail(requestParams.value)
				.then((res: any) => {
					state.tableData = res.result?.items ?? [];
					state.total = res.result?.total ?? 0;
					state.loading = false;
				})
				.catch(() => {
					state.loading = false;
				});
			break;
		case 'hotspotSubclass': // 热点类型小类统计明细
			exportMethod.value = departmentHotSmallDetailExport; // 导出接口
			requestParams.value = {
				PageIndex: state.queryParams.PageIndex,
				PageSize: state.queryParams.PageSize,
				HotspotCode: routeQueryParams.HotspotCode,
				StartTime: state.queryParams.crTime[0],
				EndTime: state.queryParams.crTime[1],
			};
			departmentHotSmallDetail(requestParams.value)
				.then((res: any) => {
					state.tableData = res.result?.items ?? [];
					state.total = res.result?.total ?? 0;
					state.loading = false;
				})
				.catch(() => {
					state.loading = false;
				});
			break;
		case 'orgHotspot': // 热点类型部门统计
			exportMethod.value = departmentHotDetailNewExport; // 导出接口
			requestParams.value = {
				PageIndex: state.queryParams.PageIndex,
				PageSize: state.queryParams.PageSize,
				HotspotCode: routeQueryParams.HotspotCode,
        OrgCode: routeQueryParams.OrgCode,
				StartTime: state.queryParams.crTime[0],
				EndTime: state.queryParams.crTime[1],
			};
			departmentHotDetailNew(requestParams.value)
				.then((res: any) => {
					state.tableData = res.result?.items ?? [];
					state.total = res.result?.total ?? 0;
					state.loading = false;
				})
				.catch(() => {
					state.loading = false;
				});
			break;
		default:
			break;
	}
};

const queryParamsRef = ref<RefType>(); // 表单ref
// 手动查询，将页码设置为1
const handleQuery = () => {
	state.queryParams.PageIndex = 1;
	queryList();
};
/** 重置按钮操作 */
const resetQuery = (formEl: FormInstance | undefined) => {
	if (!formEl) return;
	formEl.resetFields();
	queryList();
};
// 交办单导出
const onJbExport = () => {
	const ids = checkTable.value.map((item: any) => item.id);
	exportAssignment(ids);
};

const tableRef = ref<RefType>();
const checkTable = ref<EmptyArrayType>([]);
const selectAllChangeEvent = ({ checked }) => {
	if (tableRef.value) {
		const records = tableRef.value.getCheckboxRecords();
		checkTable.value = records;
		console.log(checked ? '所有勾选事件' : '所有取消事件', records);
	}
};

const selectChangeEvent = ({ checked }) => {
	if (tableRef.value) {
		const records = tableRef.value.getCheckboxRecords();
		checkTable.value = records;
		console.log(checked ? '勾选事件' : '取消事件', records);
	}
};
const isChecked = computed(() => {
	return !Boolean(checkTable.value.length);
});
const toolbarRef = ref<RefType>();
onMounted(() => {
	if (routeQueryParams.StartTime && routeQueryParams.EndTime) {
		state.queryParams.crTime = [routeQueryParams.StartTime, routeQueryParams.EndTime];
	}
	queryList();
	if (tableRef.value && toolbarRef.value) {
		tableRef.value.connect(toolbarRef.value);
	}
});
</script>
